<template>
  <div>
    <div class="row">
      <label>Номер карты</label>
    </div>
    <input name="Номер карты"
           v-validate="'required|cardNumberValidate'"
           class="free-message-space"
           :class="{error: vErrors.has('Номер карты')}"
           type="tel"
           v-mask="mask"
           @input="bar"
           :value="cardFields.description.value">
    <img v-show="cardImg" :src="cardImg">
    <validate-message v-show="vErrors.has('Номер карты')">
      {{ vErrors.first('Номер карты') }}
    </validate-message>
    <div class="row">
      <label>Срок действия</label>
    </div>
    <div class="row">
      <div class="columns six">
        <multiselect
          id="valid_month"
          @input="change"
          placeholder="Месяц"
          name="месяц"
          :vValidateRules="'required'"
          :options="monthes"
          v-model.number="cardFields.valid_month.value"
          :max-height="offsetHeight">
        </multiselect>
        <validate-message v-show="vErrors.has('valid_month')">
          {{ vErrors.first('valid_month') }}
        </validate-message>
      </div>
      <div class="columns six">
        <multiselect
          id="valid_year"
          name="год"
          :vValidateRules="'required'"
          @input="change"
          placeholder="Год"
          :options="createArrayOfStringsFromRange(new Date().getFullYear() - 2000, new Date().getFullYear() - 2000 + 20)"
          v-model.number="cardFields.valid_year.value"
          :max-height="offsetHeight">
        </multiselect>
        <validate-message v-show="vErrors.has('valid_year')">
          {{ vErrors.first('valid_year') }}
        </validate-message>
      </div>
    </div>
  </div>
</template>

<script>
  import cardType from 'credit-card-type'
  import Multiselect from '@/UI/Multiselect'
  import reduce from 'lodash/reduce'
  import VuexErrorBlock from '@/components/Validators/VuexErrorBlock'
  import ErrorHandleMixin from '@/mixins/ErrorHandleMixin'

  export default {
    name: 'card-form',
    components: {
      VuexErrorBlock,
      Multiselect
    },
    mixins: [ErrorHandleMixin],
    data () {
      return {
        offsetHeight: 100,
        value: null,
        options: ['list', 'of', 'options'],
        error: false,
        cardImg: '',
        mask: '',
        isAllValidated: false,
        cardFields: {
          description: {
            value: '',
            validated: false
          },
          valid_year: {
            value: '',
            validated: false
          },
          valid_month: {
            value: '',
            validated: false
          }
        }
      }
    },
    methods: {
      change (val, id) {
        this.$validator.validate(id, val).then((isValidated) => this.cardFields[id].validated = isValidated)
      },
      bar ({target}) {
        const inputValue = target.value.replace(/-/g, '')
        try {
          const card = cardType(inputValue)[0]
          const cardLength = card.lengths.pop()
          this.mask = '#'
          for (let i = 1; i < cardLength; i++) {
            if (i > 15) {
              this.mask += '#'
            } else {
              this.mask += i % 4 !== 0 ? '#' : '-#'
            }
          }
          this.cardImg = inputValue.length !== 0 ? `/lk/static/img/my-accounts/${card.type}.png` : ''
        } catch (e) {
          this.mask = '####-####-####-####'
        }
        this.$validator.validate('Номер карты', target.value).then((isValidated) => this.cardFields.description.validated = isValidated)
        this.cardFields.description.value = target.value
      },
      createArrayOfStringsFromRange (from, to) {
        let arrayOfString = []
        for (let i = from; i <= to; i++) {
          arrayOfString.push(String(i))
        }
        return arrayOfString
      }
    },
    computed: {
      monthes () {
        if (this.cardFields.valid_year.value && this.cardFields.valid_year.value.toString() === this.$dayjs().format('YY')) {
          return this.createArrayOfStringsFromRange(this.$dayjs().format('M'), 12)
        }
        return this.createArrayOfStringsFromRange(1, 12)
      }
    },
    watch: {
      cardFields: {
        handler () {
          const isAllValidated = Object.keys(this.cardFields).reduce((acc, field) => {
            console.log(field, this.cardFields[field].validated)
            return (acc === false) ? false : this.cardFields[field].validated
          }, true)
          this.isAllValidated = isAllValidated;
          if (isAllValidated) {
            const formattedCard = reduce(this.cardFields, (result, value, key) => ({
              ...result,
              [key]: key !== 'description' ? value.value : value.value.replace(/-/g, '')
            }), {})
            this.$emit('input', formattedCard)
          } else {
            this.$emit('input', null)
          }
        },
        deep: true
      }
    },
    mounted () {
      let modal = document.querySelector('.v--modal');
      let modalMultiselectArray = document.querySelectorAll('.v--modal .multiselect');
      modalMultiselectArray.forEach(item => {
        this.offsetHeight = (modal.getBoundingClientRect().x + modal.getBoundingClientRect().height) - (item.getBoundingClientRect().x + item.getBoundingClientRect().height) + 30;
      });
      this.$validator.attach({name: 'valid_year', rules: 'required'})
      this.$validator.attach({name: 'valid_month', rules: 'required'})
    }
  }
</script>

<style scoped>
  div {
    position: relative;
  }

  img {
    position: absolute;
    margin-top: 3px;
    top: 132px;
    right: 5px;
  }

  .red {
    position: absolute;
    margin-top: -40px;
  }
</style>
